#include <file.au3>
#include <array.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
Opt("GUIOnEventMode", 1)
#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("Dir Convert", 395, 284, -1, -1, -1, BitOR($WS_EX_TOOLWINDOW,$WS_EX_WINDOWEDGE))
GUISetOnEvent($GUI_EVENT_CLOSE, "Form1Close")
GUISetOnEvent($GUI_EVENT_MINIMIZE, "Form1Minimize")
GUISetOnEvent($GUI_EVENT_MAXIMIZE, "Form1Maximize")
GUISetOnEvent($GUI_EVENT_RESTORE, "Form1Restore")
$Group1 = GUICtrlCreateGroup("Ŀ", 16, 128, 361, 97)
$Label1 = GUICtrlCreateLabel("ַ", 32, 152, 46, 17)
GUICtrlSetOnEvent(-1, "Label1Click")
$Label2 = GUICtrlCreateLabel("Ŀ¼", 32, 184, 32, 17)
GUICtrlSetOnEvent(-1, "Label2Click")
$Input2 = GUICtrlCreateInput("", 83, 184, 217, 21)
GUICtrlSetOnEvent(-1, "Input2Change")
$Combo2 = GUICtrlCreateCombo("UTF8-S", 83, 153, 217, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "GBK|BIG5|UTF8-S|UTF8-T")
GUICtrlSetOnEvent(-1, "Combo2Change")
$Button1 = GUICtrlCreateButton("", 312, 184, 57, 25)
GUICtrlSetOnEvent(-1, "Button1Click")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group2 = GUICtrlCreateGroup("ת", 16, 16, 361, 97)
$Label3 = GUICtrlCreateLabel("ַ", 32, 40, 46, 17)
GUICtrlSetOnEvent(-1, "Label3Click")
$Label4 = GUICtrlCreateLabel("Ŀ¼", 32, 72, 32, 17)
GUICtrlSetOnEvent(-1, "Label4Click")
$Combo1 = GUICtrlCreateCombo("GBK", 83, 40, 217, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
GUICtrlSetData(-1, "GBK|BIG5|UTF8-S|UTF8-T")
GUICtrlSetOnEvent(-1, "Combo1Change")
$Input1 = GUICtrlCreateInput("d:\www\xs", 83, 74, 217, 21)
GUICtrlSetOnEvent(-1, "Input1Change")
$Button2 = GUICtrlCreateButton("", 312, 72, 59, 25)
GUICtrlSetOnEvent(-1, "Button2Click")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Progress1 = GUICtrlCreateProgress(0, 266, 394, 17)
$Button3 = GUICtrlCreateButton("ʼ", 312, 232, 57, 25)
GUICtrlSetOnEvent(-1, "Button3Click")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

While 1
	Sleep(100)
WEnd

Func Button1Click()
   Local $dir = GUICtrlRead($input2)
   Local $var = FileSelectFolder("Select Target Folder", "", 1, $dir)
   GUICtrlSetData($input2, $var)
EndFunc

Func Button2Click()
   Local $dir = GUICtrlRead($input1)
   Local $var = FileSelectFolder("ѡԴĿ¼", "", 1, $dir)
   GUICtrlSetData($input1, $var)
EndFunc

Func Button3Click()
   Local $v = setup()
   if(not $v ) Then
	  showError("unknow error")
	  Return
   EndIf
   
   startConvert()
   convert_dir($inchar, $outchar, $font, $sPath, $tPath)
   stopConvert()
   MsgBox(262144, "Message", "Convert finish")

EndFunc

Func startConvert()
   GUICtrlSetData($Button3, "ж")
   ProgressOn("Convert now ...", "", "0%")
EndFunc

Func stopConvert()
   GUICtrlSetData($Button3, "ʼ")
   ProgressOff()
EndFunc


Func Combo1Change()

EndFunc
Func Combo2Change()

EndFunc
Func Form1Close()
   Exit
EndFunc
Func Form1Maximize()

EndFunc
Func Form1Minimize()

EndFunc
Func Form1Restore()

EndFunc
Func Input1Change()

EndFunc
Func Input2Change()

EndFunc
Func Label1Click()

EndFunc
Func Label2Click()

EndFunc
Func Label3Click()

EndFunc
Func Label4Click()

EndFunc

func setup()
   Global $inchar, $outchar, $font, $sPath, $tPath
   $inchar = GUICtrlRead($Combo1)
   $outchar = GUICtrlRead($Combo2)
   $sPath = GUICtrlRead($input1)
   $tPath = GUICtrlRead($input2)
   
   if($inchar = "GBK" Or $inchar="UTF8-S") Then
	  $font = "s"
   Else
	  $font = "t"
   EndIf
   
   if(StringLeft($inchar, 4) = "UTF8") Then
	  $inchar = "UTF8"
   EndIf
   
   if(StringLeft($outchar, 4) = "UTF8") Then
	  $outchar = "UTF8"
   EndIf
      
   if($inchar = $outchar) Then
	  showError("ԭַĿַһ, ת")
	  Return 0
   EndIf
   
   if(stringlen($sPath)<4) Then
	  showError("ԭĿ¼Ϊ")
	  return 0
   EndIf
   
   if(StringLen($tPath)<4) Then
	  $tPath = $sPath & "_" & $outchar
	  GUICtrlSetData($input2, $tPath)
   EndIf
	  
   return 1
     
EndFunc

Func showError($message)
	  MsgBox(16, "Error Message", $message)
EndFunc


Func convert_dir($inchar, $outchar, $font, $sPath, $tPath)
   
	Local $hSearch, $sFile, $sFileList, $sDelim = "|", $sFilter = "*"
	$sPath = StringRegExpReplace($sPath, "[\\/]+\z", "") & "\" ; ensure single trailing backslash
	$tPath = StringRegExpReplace($tPath, "[\\/]+\z", "") & "\" ; ensure single trailing backslash

	If Not FileExists($sPath) Then 
	  ;stopConvert()
	  Return SetError(1, 1, "")
	EndIf
	
	$hSearch = FileFindFirstFile($sPath & $sFilter)
	If @error Then 
	  ;stopConvert()
	  Return SetError(4, 4, "")
   EndIf
   
   convert($inchar, $outchar, $font, $sPath & "*.*", $tPath & "*.*")

	While 1
		$sFile = FileFindNextFile($hSearch)
		If @error Then ExitLoop

		If @extended = 0 Then

		Else
			;set_status("Convert: " & $outchar & " : " & $sPath & $sFile);
			convert_dir($inchar, $outchar, $font, $sPath & $sFile, $tPath & $sFile)
		EndIf
	WEnd
	FileClose($hSearch)
	

	
EndFunc

Func convert($inchar, $outchar, $font, $source, $target)
   ProgressSet(Random(1,100), $source)
	Static $cmd = @ScriptDir & "/convert.exe "
	$source = StringReplace($source, "/", "\")
	$target = StringReplace($target, "/", "\")
	$scmd = $cmd & "/i:" & $inchar & " /o:" & $outchar & " /f:" & $font & " " & $source & " " & $target
	;MsgBox(0, '', $scmd)
	RunWait($scmd, "", @SW_HIDE)
	;Run($scmd)
   ProgressSet(100, "Convert ok")
EndFunc